<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>

<xsl:template match="/">

<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-16" />
		<title>Bugblatter's Whois plugin for Half-life - On-line Database</title>
		<xsl:choose>
			<xsl:when test="player">
				<link rel="stylesheet" href="../rbbot3.css" type="text/css" />
			</xsl:when>
			<xsl:otherwise>
				<link rel="stylesheet" href="rbbot3.css" type="text/css" />
			</xsl:otherwise>
		</xsl:choose>
	</head>
	<body text="white">		
		<table class="structure" cellpadding="0" cellspacing="0">
			<tr>
				<td>
					<div class="maintitle">
              The Ravenous Bugblatter Beast of Traal
          </div>
					<div class="subtitle">
              Stupid, but extremely ravenous!
          </div>

					<table class="mainmenu">
					<tr class="mainmenu">
					<td class="mainmenufirst"><a class="mainmenu" href="http://www.ravenousbugblatterbeast.pwp.blueyonder.co.uk/BugblatterPlugins/plugin_blatt_whois/Docs">plugin_blatt_whois player information report</a></td>
					</tr>
					<tr class="mainmenu">
					<td class="scrollmenu" onmouseover="inbox=true;" onmouseout="inbox=false;" colspan="3">
					<div id="sb"></div>
					</td>
					</tr>
					</table>
				</td>
			</tr>

			<tr>
				<td>
					<table class="structure" cellpadding="0" cellspacing="0">
						<tr>
							<td class="nestedcontentborder">

								<xsl:choose>
									<xsl:when test="player">
										<h2>Player Overview</h2>
										<xsl:call-template name="overview" />

										<h2>Names</h2>
										<xsl:call-template name="names" />

										<h2>IP Addresses</h2>
										<xsl:call-template name="ips" />

										<h2>Connections</h2>
										<xsl:call-template name="connections" />

										<h2>Player History</h2>
										<xsl:call-template name="notes" />									
									</xsl:when>

									<xsl:when test="notes">
										<h2>Server Report</h2>
										<xsl:call-template name="globalnotes" />
									</xsl:when>
									
									<xsl:when test="search">
										<xsl:copy-of select="search" />
									</xsl:when>
								</xsl:choose>
							</td>	

						<td class="rightmenu">
							<div class="rightmenu">
							<div class="navheading">Whois Information</div>
								<xsl:choose>
									<xsl:when test="player">										
										<div class="navitem"><a class="navitem" href="../globalnotes.xml">Server Report</a></div>
										<div class="navitem"><a class="navitem" href="../search.xml">Search Players</a></div>
									</xsl:when>
									<xsl:otherwise>
										<div class="navitem"><a class="navitem" href="globalnotes.xml">Server Report</a></div>
										<div class="navitem"><a class="navitem" href="search.xml">Search Players</a></div>
									</xsl:otherwise>
								</xsl:choose>										
							<div class="navheading">Links</div>
							<div class="navitem"><a class="navitem" target="_blank" href="http://www.ravenousbugblatterbeast.pwp.blueyonder.co.uk">Bugblatter Site</a></div>
							<div class="navitem"><a class="navitem" target="_blank" href="http://www.adminmod.org">Adminmod Site</a></div>
							<div class="navitem"><a class="navitem" target="_blank" href="http://www.metamod.org">Metamod Site</a></div>
							<div class="navitem"><a class="navitem" target="_blank" href="http://logd.sourceforge.net">Logd Site</a></div>
							<div class="navheading">Forums</div>
							<div class="navitem"><a class="navitem" target="_blank" href="http://www.ozforums.com/forumdisplay.php?forumid=62">Adminmod Forums</a></div>							
							<div class="navheading">Other Information</div>							
							<div class="navitem"><a class="navitem" href="http://www.ravenousbugblatterbeast.pwp.blueyonder.co.uk/Website/licence.htm">Legal Information</a></div>
							</div>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
</body>
</html>
</xsl:template>

<xsl:template name="overview">
	<xsl:variable name="kills" select="document(concat(player/@hash,'/',player/@authid,'_kills.xml'))"/>
	<table class="structure" cellpadding="0" cellspacing="0" width="90%">
		<tr>
			<td>WON/Steam ID</td>
			<td><xsl:value-of select="player/@authid" /></td>

			<td>Watch set</td>
			<td>No</td>													
		</tr>
		<tr>
			<td>Kills Administered</td>
			<td><xsl:value-of select="$kills/performance/kills/administered" /></td>
			<td>Kills Unmonitored</td>
			<td><xsl:value-of select="$kills/performance/kills/unmonitored" /></td>
		</tr>
		<tr>
			<td>Deaths Administered</td>
			<td><xsl:value-of select="$kills/performance/deaths/administered" /></td>													
			<td>Deaths Unmonitored</td>
			<td><xsl:value-of select="$kills/performance/deaths/unmonitored" /></td>
		</tr>
	</table>
</xsl:template>

<xsl:template name="names">
	<xsl:variable name="names" select="document(concat(player/@hash,'/',player/@authid,'_names.xml'))"/>
	<xsl:variable name="allnames" select="document('names.xml')"/>
	<xsl:variable name="ids" select="document('ids.xml')"/>
	<xsl:variable name="myauthid" select="player/@authid" />
	<table>
		<tr>
			<th class="datatablefirst">Alias</th>
			<th class="datatable">Rounds</th>
			<th class="datatable">Other WONIDs</th>
		</tr>
		<xsl:for-each select="$names/names/name">
			<xsl:sort select="count"/>
			<tr>
				<td class="datatablefirst"><xsl:value-of select="alias"/></td>
				<td class="datatable"><xsl:value-of select="count"/></td>
				<td class="datatable">
					<table border="0">
						<tr>
							<td>
								<xsl:for-each select="$allnames/names/name[normalize-space(translate(.,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz'))=normalize-space(translate(current()/alias,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')) and @authid!=$myauthid]">
									<div>
										<xsl:element name="a">
											<xsl:attribute name="href">../<xsl:value-of select="$ids/ids/id/@hash[../@authid=current()/@authid]"/>/<xsl:value-of select="@authid"/>.xml</xsl:attribute>
											<xsl:value-of select="@authid"/>
										</xsl:element>
									</div>
								</xsl:for-each>
							</td>
							<td>
								&#160;
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</xsl:for-each>
	</table>
</xsl:template>

<xsl:template name="ips">
	<xsl:variable name="ips" select="document(concat(player/@hash,'/',player/@authid,'_ips.xml'))"/>
	<table>
		<tr>
			<th class="datatablefirst">Address</th>
			<th class="datatable">Rounds</th>
		</tr>
		<xsl:for-each select="$ips/ips/ip">
			<xsl:sort select="count"/>
			<tr>
				<td class="datatablefirst"><xsl:value-of select="address"/></td>
				<td class="datatable"><xsl:value-of select="count"/></td>
			</tr>
		</xsl:for-each>
	</table>
</xsl:template>

<xsl:template name="connections">
	<xsl:variable name="connections" select="document(concat(player/@hash,'/',player/@authid,'_connections.xml'))"/>
	<table>
		<tr>
			<th class="datatablefirst">Date</th>
			<th class="datatable">Number of connections</th>
		</tr>
		<xsl:for-each select="$connections/connections/connection">			
			<tr>
				<td class="datatablefirst"><xsl:value-of select="date"/></td>
				<td class="datatable"><xsl:value-of select="count"/></td>
			</tr>
		</xsl:for-each>
	</table>
</xsl:template>


<xsl:template name="notes">
	<xsl:variable name="notes" select="document(concat(player/@hash,'/',player/@authid,'_notes.xml'))"/>
	<table>
		<tr>
			<th class="datatablefirst">Date</th>
			<th class="datatable">Action</th>
			<th class="datatable">Admin</th>
			<th class="datatable">Additional Data</th>
			<th class="datatable">Message</th>
		</tr>
		<xsl:for-each select="$notes/notes/note">			
			<tr>
				<td class="datatablefirst"><xsl:value-of select="date"/></td>
				<td class="datatable"><xsl:value-of select="type"/></td>
				<td class="datatable">
					<xsl:choose>
						<xsl:when test="admin/@authid=''"><xsl:value-of select="admin"/></xsl:when>
						<xsl:otherwise>
							<xsl:element name="a">
								<xsl:attribute name="href">../<xsl:value-of select="admin/@hash"/>/<xsl:value-of select="admin/@authid"/>.xml</xsl:attribute>
								<xsl:value-of select="admin"/> (<xsl:value-of select="admin/@authid"/>)
							</xsl:element>
						</xsl:otherwise>
					</xsl:choose>
				</td>
				<td class="datatable"><xsl:value-of select="data"/>&#160;</td>
				<td class="datatable"><xsl:value-of select="message"/>&#160;</td>
			</tr>
		</xsl:for-each>
	</table>
</xsl:template>

<xsl:template name="globalnotes">
	<table class="datatable">
		<tr class="datatable">
			<th class="datatablefirst">Date</th>
			<th class="datatable">Action</th>
			<th class="datatable">Admin</th>
			<th class="datatable">Target</th>
			<th class="datatable">Additional Data</th>
			<th class="datatable">Message</th>
		</tr>
		<xsl:for-each select="notes/note">			
			<tr class="datatable">
				<td class="datatablefirst"><xsl:value-of select="date"/></td>
				<td class="datatable"><xsl:value-of select="type"/></td>
				<td class="datatable">
					<xsl:choose>
						<xsl:when test="admin/@authid=''"><xsl:value-of select="admin"/></xsl:when>
						<xsl:otherwise>
							<xsl:element name="a">
								<xsl:attribute name="href"><xsl:value-of select="admin/@hash"/>/<xsl:value-of select="admin/@authid"/>.xml</xsl:attribute>
								<xsl:value-of select="admin"/> (<xsl:value-of select="admin/@authid"/>)
							</xsl:element>
						</xsl:otherwise>
					</xsl:choose>
				</td>
				<td class="datatable">
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="target/@hash"/>/<xsl:value-of select="target/@authid"/>.xml</xsl:attribute>
						<xsl:value-of select="target"/> (<xsl:value-of select="target/@authid"/>)
					</xsl:element>
				</td>
				<td class="datatable"><xsl:value-of select="data"/>&#160;</td>
				<td class="datatable"><xsl:value-of select="message"/>&#160;</td>
			</tr>
		</xsl:for-each>
	</table>
</xsl:template>

</xsl:stylesheet>
